<p align="center">
  <img src="docs/images/icon_magic_book.png" alt="Bootstrap logo" width="200" height="200">
</p>

<h1 align="center">
  Magic Pantry
</h1>
<p align="center"> 
  An Android application to scan grocery receipts, keep track of ingredients in your pantry and create recipes.
</p>
<p align="center">
  <a href="https://andyliucodes.github.io/MagicPantry/">Explore more!</a>
</p>

## 📱 Features

1. Keeps track of the ingredients in your pantry at home
1. Scan your shopping receipts to automatically add the items to your pantry (OCR)
1. Receive notifications when low on ingredients
1. Recipe system
   1. Stores your recipes
   1. Shows the available recipes you can make with the ingredients in your pantry
   1. Share your recipes with others
   1. Generate shopping list for missing ingredients in a recipe

## ✨ Show and Tell Demo 1

- UI mockup [Tyler]
- MVVM UML Diagram [Jason]
- Features (Code)
  - Basic UI [Andy]
  - Manual input of ingredients [Andy]
  - Receipt Scanning
    - Get data from receipt [Elaine/Jason]
    - Parsing relevant data [Elaine/Jason]
  - Setup database with ingredients table [Tyler]
  - Giving preview of ingredients and fix mistakes before submitting [Tyler]

## ⭐ Show and Tell Demo 2

- Pantry
  - Add ingredient to shopping list [Andy]
  - Added error checking for adding an ingredient [Andy]
  - Users can specify when an ingredient is low [Andy]
  - Improve robustness of scanner [Jason]
- Recipe
  - Add, edit and delete a recipe [Elaine/Andy]
  - Cook a recipe to consume pantry ingredients [Tyler]
  - View all recipes [Jason]
  - View a single recipe [Jason]
- Shopping List
  - Add, edit and delete from the shopping list [Andy]
  - Adding ingredients to your pantry from the shopping list [Andy]
- Notification
  - View all notifications [Elaine/Tyler]
  - View single notification [Elaine]
  - Android notifications not complete yet - using mock data currently

## 🌟 Final Demo

- Pantry
  - Add notification fields for an ingredient [Andy]
  - Bug fixes with receipt scanner [Andy/Jason]
- Recipes
  - Add, edit and delete ingredients from recipe [Andy/Tyler]
  - Add missing ingredients from a recipe [Andy]
  - Delete a recipe [Elaine]
  - UI fixes with adding and editing a recipe [Elaine]
- Notification
  - Creates a notification when an ingredient amount falls below it's set threshold value [Jason]
  - Generates an Android notification that directs to notification [Jason]
- DB updates to ensure validity of pantry ingredient amounts and cookable recipes [Tyler]

## 👥 Team

| Name              | Email           | Student # |
| ----------------- | --------------- | --------- |
| Elaine Abraham    | eabraham@sfu.ca | 301368157 |
| Jason Esquilona   | jesquilo@sfu.ca | 301369208 |
| Andy Liu          | ala158@sfu.ca   | 301319435 |
| Bao (Tyler) Trinh | bvtrinh@sfu.ca  | 301319439 |
